module Detector (
	iCLK_27,
	iRed, iGreen, iBlue,
	iVGA_X, iVGA_Y,
	iVGA_BLANK,
	iGxy,iRxy,iYxy,iBxy,iOxy,
	oG,oR,oY,oB,oO );
	
	input				iCLK_27;								//27MHz clock
	input	[9:0]		iRed, iGreen, iBlue;				//RGB signal from decoder
	input	[9:0]		iVGA_X, iVGA_Y;					//Current pixel location
	input				iVGA_BLANK;							//VGA blank (active low)
	input	[19:0]	iGxy, iRxy, iYxy, iBxy, iOxy;	//Input X and Y coordinates for Detection location for
																//the 5 colors
	
	output reg	oG,oR,oY,oB,oO;		//Note outputs
	
	reg			tempG,tempR,tempY,tempB,tempO;
	reg [19:0]	counter;	//Used to generate 60Hz
	
	wire			isG,isR,isY,isB,isO;
	wire	[9:0]	Gy,Gx, Ry,Rx, Yy,Yx, By,Bx, Oy,Ox;
	//wire	isWhite;
	
	assign Gy = iGxy[9:0];
	assign Gx = iGxy[19:10];
	assign Ry = iRxy[9:0];
	assign Rx = iRxy[19:10];
	assign Yy = iYxy[9:0];
	assign Yx = iYxy[19:10];
	assign By = iBxy[9:0];
	assign Bx = iBxy[19:10];
	assign Oy = iOxy[9:0];
	assign Ox = iOxy[19:10];
	
	
	
//	parameter Gy=10'd371, Gx=10'd210, 
//				 Ry=10'd369, Rx=10'd267, 
//				 Yy=10'd367, Yx=10'd324, 
//				 By=10'd369, Bx=10'd380, 
//				 Oy=10'd371, Ox=10'd435 ;

	//threshold logic here to generate isG/R/Y/B/O	
	//assign isWhite = (iRed[9:8]==2'b11)&&(iGreen[9:8]==2'b11)&&(iBlue[9:8]==2'b11);
	//assign isG = (iRed[9]==1'b1)&&(iGreen[9]==1'b1)&&(iBlue[8]==2'b1);
	//assign isR = (iRed[9]==1'b1)&&(iGreen[9]==1'b1)&&(iBlue[8]==2'b1);
	//assign isY = (iRed[9]==1'b1)&&(iGreen[9]==1'b1)&&(iBlue[8]==2'b1);

	
	//temporarily assign oG to tempG
	//assign oG = tempG;
	
	assign isG = (iGreen[9:8]==2'b11 && iRed[9]==1'd0 && iBlue[9]==1'd0);
	assign isR = (iRed==10'b1111111111 && ~iGreen[9] && iGreen[8] && iBlue[9]==1'b0);
	assign isY = (iRed[9] && iGreen[9] && iBlue==10'd0);
	assign isB = (~iRed[9] && (iRed[8] | iRed[7]) && (iGreen[9] | iGreen[8]) && iBlue[9:6]==4'b1111);
//	assign isO = ;
		
	always @(posedge iCLK_27) begin
		if (iVGA_BLANK) begin
			if (iVGA_Y==Gy && iVGA_X==Gx && isG) begin
				oG <= 1'b1;
			end
			else begin
				oG <= 1'b0;
			end
			if (iVGA_Y==Ry && iVGA_X==Rx && isR) begin
				oR <= 1'b1;
			end
			else begin
				oR <= 1'b0;
			end
			if (iVGA_Y==Yy && iVGA_X==Yx && isY) begin
				oY <= 1'b1;
			end
			else begin
				oY <= 1'b0;
			end
			if (iVGA_Y==By && iVGA_X==Bx && isB) begin
				oB <= 1'b1;
			end
			else begin
				oB <= 1'b0;
			end
			if (iVGA_Y==Oy && iVGA_X==Ox && iRed[9]) begin
				oO <= 1'b1;
			end
			else begin
				oO <= 1'b0;
			end
		end
		
//		if (counter==20'd450000) begin
//			oG <= tempG;	//Update the note signal outputs
//			oR <= tempR;
//			oY <= tempY;
////			oB <= tempB;
////			oO <= tempO;
//			tempG <= 1'b0;	//Reset the temp regs
//			tempR <= 1'b0;
//			tempY <= 1'b0;
////			tempB <= 1'b0;
////			tempO <= 1'b0;
//			counter <= 20'b0;	//Reset the Counter
//		end
//		else begin
//			counter <= counter + 20'b1;
//		end
	end
	
endmodule
