// Holds buttons down before strum until new buttons are pressed
// Coded by Jeff Yates and Tom Gowing
// Cornell University Spring 2011
// *******************************************************************************
module FretPresser (
	iCLK,
	iNewFrame,
	iFrameCount,
	iBufferFrameCount,
	iNotes,
	iValid,
	oNotes );
	
	input 		iCLK;
	input			iNewFrame;				// Signals start of new frame
	input	[7:0]	iFrameCount;			// Global frame count
	input [7:0]	iBufferFrameCount;	// Frame to strum next note on
	input	[4:0]	iNotes;					// Notes to strum (from buffer)

	input			iValid;	// Is buffer output valid?
	
	output reg [4:0]	oNotes;	// Output to guitar
	
	// Press buttons 2 frames before strum if they are valid and hold until next button presses
	always @(posedge iCLK) begin
		oNotes <= ((iFrameCount==(iBufferFrameCount-8'd2))&&iValid&&iNewFrame) ? iNotes : oNotes;
	end
	
endmodule
