// Determines new detection of a note and holds output high until a new frame
// Coded by Jeff Yates and Tom Gowing
// Cornell University Spring 2011
// *******************************************************************************
module newNote (
	iCLK,
	iNote,
	iNewFrame,
	oNewNote
);

	input iCLK;
	input iNote;		
	input iNewFrame;	// Signals start of new frame
	
	output reg oNewNote;
	
	reg [1:0] note;	// Note history buffer
	
	always @(posedge iCLK) begin
		note <= {note[0], iNote};	// Update buffer like a shift register	
		// Output held until beginning of next frame
		oNewNote <= (iNewFrame) ? (1'b0) : (oNewNote || (~note[1] & note[0]));
	end
	
endmodule
